Properties Methods Events Config Options Direct Link

    Observable
      Resizable

# Class Ext.Resizable

Package: | Ext
Defined In: | Resizable.js
Class: | Resizable
Extends: | Observable

Applies drag handles to an element to make it resizable. The drag handles are inserted into the element and positioned absolute. Some elements, such as a textarea or image, don't support this. To overcome that, you can wrap the textarea in a div and set 'resizeChild' to true (or to the id of the element), or set wrap:true in your config and the element will be wrapped for you automatically.

Here is the list of valid resize handles:

    Value   Description
    ------  -------------------
     'n'     north
     's'     south
     'e'     east
     'w'     west
     'nw'    northwest
     'sw'    southwest
     'se'    southeast
     'ne'    northeast
     'all'   all

Here's an example showing the creation of a typical Resizable:

    var resizer = new Ext.Resizable('element-id', {
        handles: 'all',
        minWidth: 200,
        minHeight: 100,
        maxWidth: 500,
        maxHeight: 400,
        pinned: true
    });
    resizer.on('resize', myHandler);

To hide a particular handle, set its display to none in CSS, or through script:
resizer.east.setDisplayed(false);

## Config Options

Config Options | Defined By
--- | ---
| adjustments : Array/String String 'auto' or an array [width, height] with values to be added to the resize operation's new size (defaults to [0,... String 'auto' or an array [width, height] with values to be added to the resize operation's new size (defaults to `[0, 0]`) | Resizable
| animate : Boolean True to animate the resize (not compatible with dynamic sizing, defaults to false) | Resizable
| constrainTo : Mixed Constrain the resize to a particular element | Resizable
| disableTrackOver : Boolean True to disable mouse tracking. This is only applied at config time. (defaults to false) | Resizable
| draggable : Boolean Convenience to initialize drag drop (defaults to false) | Resizable
| duration : Number Animation duration if animate = true (defaults to 0.35) | Resizable
| dynamic : Boolean True to resize the element while dragging instead of using a proxy (defaults to false) | Resizable
| easing : String Animation easing if animate = true (defaults to `'easingOutStrong'`) | Resizable
| enabled : Boolean False to disable resizing (defaults to true) | Resizable
| handleCls : String A css class to add to each handle. Defaults to `''`. | Resizable
| handles : String String consisting of the resize handles to display (defaults to undefined). Specify either 'all' or any of 'n s e w n... String consisting of the resize handles to display (defaults to undefined). Specify either `'all'` or any of `'n s e w ne nw se sw'`. | Resizable
| height : Number The height of the element in pixels (defaults to null) | Resizable
| heightIncrement : Number The increment to snap the height resize in pixels (only applies if `dynamic==true`). Defaults to `0`. | Resizable

listeners : Object
A config object containing one or more event handlers to be added to this object during initialization. This should ...

A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.

DOM events from ExtJs Components

While some ExtJs Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually only done when extra value can be added. For example the DataView's `click` event passing the node clicked on. To access DOM events directly from a Component's HTMLElement, listeners must be added to the Element after the Component has been rendered. A plugin can simplify this step:

    // Plugin is configured with a listeners config object.
    // The Component is appended to the argument list of all handler functions.
    Ext.DomObserver = Ext.extend(Object, {
        constructor: function(config) {
            this.listeners = config.listeners ? config.listeners : config;
        },

        // Component passes itself into plugin's init method
        init: function(c) {
            var p, l = this.listeners;
            for (p in l) {
                if (Ext.isFunction(l[p])) {
                    l[p] = this.createHandler(l[p], c);
                } else {
                    l[p].fn = this.createHandler(l[p].fn, c);
                }
            }

            // Add the listeners to the Element immediately following the render call
            c.render = c.render.createSequence(function() {
                var e = c.getEl();
                if (e) {
                    e.on(l);
                }
            });
        },

        createHandler: function(fn, c) {
            return function(e) {
                fn.call(this, e, c);
            };
        }
    });

    var combo = new Ext.form.ComboBox({

        // Collapse combo when its element is clicked on
        plugins: [ new Ext.DomObserver({
            click: function(evt, comp) {
                comp.collapse();
            }
        })],
        store: myStore,
        typeAhead: true,
        mode: 'local',
        triggerAction: 'all'
    });

Observable

| maxHeight : Number The maximum height for the element (defaults to 10000) | Resizable
| maxWidth : Number The maximum width for the element (defaults to 10000) | Resizable
| minHeight : Number The minimum height for the element (defaults to 5) | Resizable
| minWidth : Number The minimum width for the element (defaults to 5) | Resizable
| minX : Number The minimum x for the element (defaults to 0) | Resizable
| minY : Number The minimum x for the element (defaults to 0) | Resizable
| multiDirectional : Boolean Deprecated. Deprecated style of adding multi-direction resize handles. | Resizable
| pinned : Boolean True to ensure that the resize handles are always visible, false to display them only when the user mouses over the r... True to ensure that the resize handles are always visible, false to display them only when the user mouses over the resizable borders. This is only applied at config time. (defaults to false) | Resizable
| preserveRatio : Boolean True to preserve the original ratio between height and width during resize (defaults to false) | Resizable
| resizeChild : Boolean/String/Element True to resize the first child, or id/element to resize (defaults to false) | Resizable
| resizeRegion : Ext.lib.Region Constrain the resize to a particular region | Resizable
| transparent : Boolean True for transparent handles. This is only applied at config time. (defaults to false) | Resizable
| width : Number The width of the element in pixels (defaults to null) | Resizable
| widthIncrement : Number The increment to snap the width resize in pixels (only applies if `dynamic==true`). Defaults to `0`. | Resizable
| wrap : Boolean True to wrap an element with a div if needed (required for textareas and images, defaults to false) in favor of the h... True to wrap an element with a div if needed (required for textareas and images, defaults to false) in favor of the handles config option (defaults to false) | Resizable

## Public Properties

Property | Defined By
--- | ---
| enabled : Boolean Writable. False if resizing is disabled. | Resizable
| proxy : Ext.Element. The proxy Element that is resized in place of the real Element during the resize operation. This may be queried using... The proxy Element that is resized in place of the real Element during the resize operation. This may be queried using Ext.Element.getBox to provide the new area to resize to. Read only. | Resizable

## Public Methods

Method | Defined By
--- | ---

Resizable( `Mixed el`, `Object config` )
Create a new resizable component
Create a new resizable component
Parameters:

- `el` : Mixed
  The id or element to resize
- `config` : Object
  configuration options

Returns:

- void

Resizable

addEvents( `Object|String o`, `string Optional.` ) : void
Adds the specified events to the list of events which this Observable may fire.
Adds the specified events to the list of events which this Observable may fire.
Parameters:

- `o` : Object|String
  Either an object with event names as properties with a value of `true` or the first event name string if multiple event names are being passed as separate parameters.
- `Optional.` : string
  Event name if multiple event names are being passed as separate parameters. Usage:

      this.addEvents('storeloaded', 'storecleared');

Returns:

- void

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object.
Appends an event handler to this object.
Parameters:

- `eventName` : String
  The name of the event to listen for.
- `handler` : Function
  The method the event invokes.
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration. properties. This may contain any of the following properties:
  - scope : Object
    The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
  - delay : Number
    The number of milliseconds to delay the invocation of the handler after the event fires.
  - single : Boolean
    True to add a handler to handle just the next firing of the event, and then remove itself.
  - buffer : Number
    Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
  - target : Observable
    Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A delayed, one-time listener.

      myDataView.on('click', this.onClick, this, {
      single: true,
      delay: 100
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      myGridPanel.on({
      'click' : {
          fn: this.onClick,
          scope: this,
          delay: 100
      },
      'mouseover' : {
          fn: this.onMouseOver,
          scope: this
      },
      'mouseout' : {
          fn: this.onMouseOut,
          scope: this
      }
      });

  Or a shorthand syntax:

      myGridPanel.on({
      'click' : this.onClick,
      'mouseover' : this.onMouseOver,
      'mouseout' : this.onMouseOut,
       scope: this
      });

Returns:

- void

Observable

destroy( [`Boolean removeEl`] ) : void
Destroys this resizable. If the element was wrapped and removeEl is not true then the element remains.
Destroys this resizable. If the element was wrapped and removeEl is not true then the element remains.
Parameters:

- `removeEl` : Boolean
  (optional) true to remove the element from the DOM

Returns:

- void

Resizable

enableBubble( `String/Array events` ) : void
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present....

Enables events fired by this Observable to bubble up an owner hierarchy by calling `this.getBubbleTarget()` if present. There is no implementation in the Observable base class.

This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.

Example:

    Ext.override(Ext.form.Field, {
        //  Add functionality to Field's initComponent to enable the change event to bubble
        initComponent : Ext.form.Field.prototype.initComponent.createSequence(function() {
            this.enableBubble('change');
        }),

        //  We know that we want Field's events to bubble directly to the FormPanel.
        getBubbleTarget : function() {
            if (!this.formPanel) {
                this.formPanel = this.findParentByType('form');
            }
            return this.formPanel;
        }
    });

    var myForm = new Ext.formPanel({
        title: 'User Details',
        items: [{
            ...
        }],
        listeners: {
            change: function() {
                // Title goes red if form has been modified.
                myForm.header.setStyle('color', 'red');
            }
        }
    });

Parameters:

- `events` : String/Array
  The event name to bubble, or an Array of event names.

Returns:

- void

Observable

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name). An event may be set to bubble up an Obse...

Fires the specified event with the passed parameters (minus the event name).

An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.

Parameters:

- `eventName` : String
  The name of the event to fire.
- `args` : Object...
  Variable number of parameters are passed to handlers.

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true.

Observable

getEl() : Ext.Element
Returns the element this component is bound to.
Returns the element this component is bound to.
Parameters:

- None.

Returns:

- `Ext.Element`

Resizable

getResizeChild() : Ext.Element
Returns the resizeChild element (or null).
Returns the resizeChild element (or null).
Parameters:

- None.

Returns:

- `Ext.Element`

Resizable

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object (shorthand for addListener.)
Appends an event handler to this object (shorthand for addListener.)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration.

Returns:

- void

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- void

Observable

relayEvents( `Object o`, `Array events` ) : void
Relays selected events from the specified Observable as if the events were fired by this.
Relays selected events from the specified Observable as if the events were fired by `this`.
Parameters:

- `o` : Object
  The Observable whose events this object is to relay.
- `events` : Array
  Array of event names to relay.

Returns:

- void

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler.
Removes an event handler.
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

resizeElement() : void
Performs resizing of the associated Element. This method is called internally by this class, and should not be called...

Performs resizing of the associated Element. This method is called internally by this class, and should not be called by user code.

If a Resizable is being used to resize an Element which encapsulates a more complex UI component such as a Panel, this method may be overridden by specifying an implementation as a config option to provide appropriate behaviour at the end of the resize operation on mouseup, for example resizing the Panel, and relaying the Panel's content.

The new area to be resized to is available by examining the state of the proxy Element. Example:

    new Ext.Panel({
        title: 'Resize me',
        x: 100,
        y: 100,
        renderTo: Ext.getBody(),
        floating: true,
        frame: true,
        width: 400,
        height: 200,
        listeners: {
            render: function(p) {
                new Ext.Resizable(p.getEl(), {
                    handles: 'all',
                    pinned: true,
                    transparent: true,
                    resizeElement: function() {
                        var box = this.proxy.getBox();
                        p.updateBox(box);
                        if (p.layout) {
                            p.doLayout();
                        }
                        return box;
                    }
               });
           }
        }
    }).show();

Parameters:

- None.

Returns:

- void

Resizable

resizeTo( `Number width`, `Number height` ) : void
Perform a manual resize and fires the 'resize' event.
Perform a manual resize and fires the 'resize' event.
Parameters:

- `width` : Number
- `height` : Number

Returns:

- void

Resizable

resumeEvents() : void
Resume firing events. (see suspendEvents) If events were suspended using the queueSuspended parameter, then all event...
Resume firing events. (see suspendEvents) If events were suspended using the `queueSuspended` parameter, then all events fired during event suspension will be sent to any listeners now.
Parameters:

- None.

Returns:

- void

Observable

suspendEvents( `Boolean queueSuspended` ) : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- `queueSuspended` : Boolean
  Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events;

Returns:

- void

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler (shorthand for removeListener.)
Removes an event handler (shorthand for removeListener.)
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

## Public Events

Event | Defined By
--- | ---

beforeresize : ( `Ext.Resizable this`, `Ext.EventObject e` )
Fired before resize is allowed. Set enabled to false to cancel resize.
Fired before resize is allowed. Set enabled to false to cancel resize.
Listeners will be called with the following arguments:

- `this` : Ext.Resizable
- `e` : Ext.EventObject
  The mousedown event

Resizable

resize : ( `Ext.Resizable this`, `Number width`, `Number height`, `Ext.EventObject e` )
Fired after a resize.
Fired after a resize.
Listeners will be called with the following arguments:

- `this` : Ext.Resizable
- `width` : Number
  The new width
- `height` : Number
  The new height
- `e` : Ext.EventObject
  The mouseup event

Resizable